# learning-languages

Repository which documents my journey in learning new languages.

Currently learning:
<p align="center">
  <img src="https://raw.githubusercontent.com/devicons/devicon/master/icons/rust/rust-original.svg" alt="Rust" width="50" height="50"/>
  <img src="https://raw.githubusercontent.com/devicons/devicon/master/icons/haskell/haskell-original.svg" alt="Haskell" width="50" height="50"/>
  <img src="https://raw.githubusercontent.com/devicons/devicon/master/icons/swift/swift-original.svg" alt="Swift" width="50" height="50"/>
</p>

(and C++, but that is gonna happen in embedded systems, so I won't document it here)

## Idea
I will spend about 5 hours a week learning each language. This is **NOT** a priority, but rather a side project to keep me entertained and to learn new things.

The main idea is to use these new languages to solve problems I would normally solve with Python. Also, as the file structure suggests, I will also do some algorithmic problems in these languages.

READMEs will be present in each practical folder, where I will document my thought process and the things I learned.

A larger, more detailed README will be present in the root of each language folder, where I will document the resources I used and the things I learned.

## Books and resources
- [The rust book](https://doc.rust-lang.org/book/)
- [Haskell Programming from first principles](http://haskellbook.com/)
- [Learn you a Haskell for great good](http://learnyouahaskell.com/)
- [Swift documentation](https://docs.swift.org/swift-book/documentation/the-swift-programming-language/)

## End goal
Achieve a somewhat adequate level of proficiency in these languages. I don't expect to be an expert, but I want to be able to write code in these languages without having to look up every single thing.
